SystemOrganization addCategory: #GODCall!

GODData subclass: #GCConference
	instanceVariableNames: 'name acronym categories url importantDates venue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym
	^ acronym! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym: conferenceAcronym
	acronym := conferenceAcronym! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories
	^ categories! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories: conferenceCategories
	categories := conferenceCategories! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates
	 ^ importantDates! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates: conferenceImportantDates
	importantDates := conferenceImportantDates! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name
	^ name! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name: conferenceName
	name := conferenceName! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue
	 ^ venue! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue: conferenceVenue
	venue := conferenceVenue! !

Object subclass: #GCImportantDates
	instanceVariableNames: 'startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:21'!
deadlineDate
	^ deadlineDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:22'!
deadlineDate: conferenceDeadlineDate
	deadlineDate := conferenceDeadlineDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate
	^ endDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate: conferenceEndDate
	endDate := conferenceEndDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:18'!
startDate
	^ startDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
startDate: conferenceStartDate
	startDate := conferenceStartDate! !

Object subclass: #GCProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCProcessor methodsFor: 'as yet unclassified' stamp: 'cms 9/27/2014 23:07'!
generateGodConferencesFrom: spreadsheet
	"comment stating purpose of message"
	^ nil.! !

!GCProcessor methodsFor: 'as yet unclassified' stamp: 'cms 9/27/2014 23:06'!
toConferenceFrom: page withSource: source
	 ^ nil.! !

Object subclass: #GCSearchFilter
	instanceVariableNames: 'searchKey category startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCSearchFilter class methodsFor: 'constructing' stamp: 'pfsm 9/28/2014 11:58'!
new
	"creates a new object with all fields nil"
	| aSearchFilter |

	aSearchFilter := super new.
	aSearchFilter searchKey: nil;
						category: nil;
						startDate: nil;
						endDate: nil;
						deadlineDate: nil.

	^ aSearchFilter! !

!GCSearchFilter class methodsFor: 'constructing' stamp: 'pfsm 9/28/2014 12:02'!
search: aSearchKey in: aCategory from: aStartDate to: anEndDate
	"constructs a new searchFilter with the corresponding arguments "
	|aSearchFilter|

	aSearchFilter := self new.
	aSearchFilter searchKey: aSearchKey;
						category: aCategory;
						startDate: aStartDate;
						endDate: anEndDate.

	 ^  aSearchFilter
		! !

!GCSearchFilter class methodsFor: 'constructing' stamp: 'pfsm 9/28/2014 12:05'!
search: aSearchKey in: aCategory from: aStartDate to: anEndDate deadline: aDeadlineDate  
	"constructs a new searchFilter with the corresponding arguments "
	|aSearchFilter|

	aSearchFilter := self new.
	aSearchFilter searchKey: aSearchKey;
						category: aCategory;
						startDate: aStartDate;
						endDate: anEndDate;
						deadlineDate: aDeadlineDate.

	 ^  aSearchFilter
		! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
category

	^ category! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:32'!
category: aCategory
"set category of the conference being searched"
	category := aCategory! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
deadlineDate

	^ deadlineDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:31'!
deadlineDate: aDeadlineDate
"set filter for searching conferences with deadline until aDeadlineDate"
	deadlineDate := aDeadlineDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
endDate

	^ endDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:32'!
endDate: anEndDate
"set filter for searching conferences with end date until anEndDate"
	endDate := anEndDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
searchKey

	^ searchKey! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:34'!
searchKey: aSearchKey
"set filter for searching conferences that contain the word aSearchKey"
	searchKey := aSearchKey! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
startDate

	^ startDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:35'!
startDate: aStartDate
"set filter for searching conferences with start date after  aStartDate"
	startDate := aStartDate! !

Object subclass: #GCVenue
	instanceVariableNames: 'place city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city
	^ city! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city: conferenceCity
	city := conferenceCity! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country
	^ country! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country: conferenceCountry
	country := conferenceCountry! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
place
	^ place! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:26'!
place: conferencePlace
	place := conferencePlace! !

Object subclass: #GODCall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:06'!
crawlConferences
	" search for conferences in web, merge information with quallis, and save in database"
	| sourcesCollection urlCollection page spreadsheetCollection spreadsheet mergedSpreadsheet|
	sourcesCollection := self getSources.
     
     	sourcesCollection do: [ :source |
   		urlCollection := self getUrlsFrom: source.
	      urlCollection do: [ :url |
			"page = GODWebPageFetcher getUrl: url.
			godConferenceCollection := GODCallProcessor toConferenceFrom: page withSource: source.
			 spreadsheet = GODOutputSpreadsheet generateSpreadsheetFrom: godConferenceCollection."
			spreadsheetCollection add: spreadsheet.
		].		
     	].

	spreadsheet =  self getQuallisFileAsSpreadsheet.
 	"mergedSpreadsheet = GODProcessor  mergeSpreadsheets: spreadsheetCollection.
      
	godConferenceCollection = GODCallProcessor generateGodConferencesFrom: mergedSpreadsheet.
	GODDBInput save: godConferenceCollection."
     ^ True.     
	! !

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:04'!
getQuallisFileAsSpreadsheet
	"comment stating purpose of message"

	 ^ nil.! !

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:01'!
getSources
	"comment stating purpose of message"

	  ^ nil.! !

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:03'!
getUrlsFrom: source
	"get urls from source, one source example is ConfSearch"

	^ nil.! !

!GODCall methodsFor: 'as yet unclassified' stamp: 'pfsm 9/27/2014 21:38'!
godCallIndexPage
	"generates the index page of GODs Call app"
	^ self subclassResponsibility! !

!GODCall methodsFor: 'as yet unclassified' stamp: 'cms 9/27/2014 22:02'!
submitForm: searchFilter
	"executes a user's query defined in the searchFilter and returns web page"
	|godConferenceCollection godSpreadsheet resultPage|
      "We still don't have theses classes so we left the flow commented "

	"godConferenceCollection :=  GODDBInput getConferences.

      godConferenceCollection := GODConferenceFilter filter: godConferenceCollection with: searchFilter.

      godSpreadsheet := GODSpreadsheetOutput generateSpreadsheetFrom: godConferenceCollection.
     
	resultPage := GODWebGenerator generateSpreadsheetPageFrom: godSpreadsheet."
     ^ resultPage. ! !
